package com.fp.frontend.controller.pgeneral.lov;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.context.RequestContext;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.enums.EnumLovOption;
import com.fp.frontend.helper.CallerHelper;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.menu.TgeneMenuSubLevelDesc;

/**
 * Clase controladora del lov asociado al bean TgeneMenuLevelDesc.
 *
 * @author WPA.
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class SubLevelLovController extends AbstractController<TgeneMenuSubLevelDesc> {

    private static final long serialVersionUID = 1L;

    public SubLevelLovController() throws Exception {
        super(TgeneMenuSubLevelDesc.class);
    }

    @PostConstruct
    private void postconstruct() throws Exception {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();
        //
        String menucode = CallerHelper.getLovParameter("pk.menucode");
        String levelcode = CallerHelper.getLovParameter("pk.levelcode");
        if (menucode == null) {
            MessageHelper.setMessageError("msg_menuNotFound");
            return;
        }
        if (levelcode == null) {
            MessageHelper.setMessageError("msg_levelNotFound");
            return;
        }
        super.getMfilters().put("pk.menucode", menucode);
        super.getMfilters().put("pk.levelcode", levelcode);

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 15; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "MENUSUBLEVELLOV";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            if (super.getMfilters().get("pk.menucode") == null) {
                MessageHelper.setMessageError("msg_menucodeRequired");
                return;
            }
            if (super.getMfilters().get("pk.levelcode") == null) {
                MessageHelper.setMessageError("msg_menuLevelRequired");
                return;
            }
            this.getMfilters().put("pk.languagecode", this.getLoginController().getRequest().getLanguage());
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk.levelcode");

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneMenuSubLevelDesc>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneMenuSubLevelDesc>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Obtiene el valor del Lov
     */
    public void setMenuSubLevel() {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(this.record);
    }

    /**
     * Obtiene el valor del Lov
     */
    public void setMenuSubLevel(TgeneMenuSubLevelDesc tgeneMenuSubLevelDesc) {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(tgeneMenuSubLevelDesc);
    }

    /**
     * Abre el lov de MenuLevel
     *
     * @param params
     */
    public static void openLov(Map<String, List<String>> params) {
        Map<String, Object> options = new HashMap<String, Object>();
        options.put("modal", true);
        options.put(EnumLovOption.HEIGHT.getLabel(), 450);
        options.put(EnumLovOption.WIDTH.getLabel(), 700);
        options.put(EnumLovOption.RESIZABLE.getLabel(), false);
        RequestContext.getCurrentInstance().openDialog("/pages/general/lov/menusublevelLov.xhtml", options, params);
    }

}
